<?php
require_once('config/config.php');
require_once('config/funciones.php');
require_once('peticiones/productos.php');

?>
<!doctype html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Actualizar categorías</title>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/5.0.1/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.11.3/css/dataTables.bootstrap5.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/v/bs5/sl-1.3.4/datatables.min.css"/>
    <link rel="stylesheet" href="https://cdn.datatables.net/v/bs5/b-2.1.1/datatables.min.css"/>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC"
          crossorigin="anonymous">
</head>
<body class="container-fluid py-5">

<div class="table-responsive w-75 m-auto">
    <table class="table table-hover table-bordered py-4" id="tabla">
        <thead>
        <tr>
            <th scope="col">SKU Configurable</th>
            <th scope="col">SKU Simples</th>
            <th scope="col">Nombre</th>
            <th scope="col">Categorías</th>
            <th scope="col"></th>
        </tr>
        </thead>
        <tbody>
        <?php
        foreach ($productos as $prod) {
            $prod = array_map('arrayUtf8', $prod);
            ?>
            <tr>
                <th scope="row"><?= $prod['config'] ?></th>
                <td><?= $prod['simples'] ?></td>
                <td><?= $prod['nombre'] ?></td>
                <td><?= $prod['cate_pais'] ?? 'Sin categorizar' ?></td>
                <td>
                    <div class="form-check">
                        <input class="form-check-input" type="checkbox">
                    </div>
                </td>
            </tr>
            <?php
        }
        ?>
        </tbody>
    </table>
</div>
<div class="modal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" id="agregar_categoria" style="background-color: rgba(0,0,0,0.5)">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Agregar categorias</h5>
                <button type="button" class="btn-close" aria-label="Cerrar" onclick="cerrar('agregar_categoria');"></button>
            </div>
            <div class="modal-body">
                <form action="procesos/agregar_categoria.php" method="post">
                    <input type="hidden" name="coditm">

                    <input type="text" name="categoria" aria-describedby="ayuda_cate">
                    <div id="ayuda_cate" class="form-text">Se deben de tener en cuenta lo siguiente:
                        <ul>
                            <li>Se permiten hasta 3 niveles</li>
                            <li>El formato a ingresar debe de ser: Categoria madre>sub-categoria>sub-categoría de la sub-categoria. Ej.: Jeans>Todos>Slouchy</li>
                            <li>Si la/s categorías ya existen en Magento se deben de llamar EXACTAMENTE igual, respetando espacios, mayúsculas, tildes, etc. De lo contrario se creará otra categoría
                            </li>
                            <li>En caso que queres agregar otra categoría distinta, de debe de separar por ;. Ej.:Jeans>Todos>Slouchy;NEW IN</li>
                        </ul>
                    </div>

                    <div class="modal-footer">
                        <button type="submit" class="btn btn-primary">Guardar</button>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>

<div class="modal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" id="quitar_categoria" style="background-color: rgba(0,0,0,0.5)">
    <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Sacar categorias</h5>
                <button type="button" class="btn-close" aria-label="Cerrar" onclick="cerrar('quitar_categoria');"></button>
            </div>
            <div class="modal-body">
                <form action="procesos/quitar_categoria.php" method="post">
                    <input type="hidden" name="coditm">

                    <div id="cates"></div>

                    <div class="modal-footer">
                        <button type="submit" class="btn btn-primary">Guardar</button>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>
<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script src="https://cdn.datatables.net/1.11.3/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.11.3/js/dataTables.bootstrap5.min.js"></script>
<script src="https://cdn.datatables.net/v/bs5/sl-1.3.4/datatables.min.js"></script>
<script src="https://cdn.datatables.net/v/bs5/b-2.1.1/datatables.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
        crossorigin="anonymous"></script>
<script>
    function cerrar(id) {
        $('#' + id + '').css('display', 'none');
    };

    function eliminar_cate(btn) {
        btn.parentElement.parentElement.removeChild(btn.parentElement);
    };

    $(document).ready(function () {
        let tabla = $('#tabla').DataTable({
            "searching": true,
            "pageLength": 25,
            "select": {
                "style": 'multi'
            },
            "language": {
                "lengthMenu": "Mostrar _MENU_ registros",
                "zeroRecords": "No se encontraron registros",
                "info": "Mostrando página _PAGE_ de _PAGES_",
                "infoEmpty": "No hay registros disponibles",
                "infoFiltered": "",
                "search": "Buscar:",
                "paginate": {
                    "first": "Primero",
                    "last": "Último",
                    "next": "Siguiente",
                    "previous": "Anterior"
                },
            },
            dom: 'Bfrtip',
            buttons: [
                {
                    text: 'Agregar categoría/s',
                    name: 'agregar',
                    enabled: false,
                    action: function () {
                        let modal = document.querySelector('#agregar_categoria'),
                            in_coditm = document.querySelector("#agregar_categoria input[name*='coditm']")
                        coditms = [];
                        modal.style.display = 'block';

                        tabla.rows({selected: true}).every(function () {
                            coditms.push(this.data()[0]);
                        });

                        in_coditm.value = coditms;
                    }
                },
                {
                    text: 'Quitar categoría/s',
                    name: 'sacar',
                    enabled: false,
                    action: function () {
                        let modal = document.querySelector('#quitar_categoria'),
                            coditms = [],
                            inputs_cate = '',
                            cates_comun = [],

                            in_coditm = document.querySelector("#quitar_categoria input[name*='coditm']"),
                            div_inputs = document.querySelector('#quitar_categoria #cates');
                        modal.style.display = 'block';

                        tabla.rows({selected: true}).every(function () {
                            coditms.push(this.data()[0]);

                            let cate_actual = this.data()[3].split(';;'),
                            compara = null,
                                cate_comun_vieja = [];

                            if (!cates_comun.length) {
                                cates_comun = cate_actual;
                            } else {
                                cate_actual.forEach(function (cate) {
                                    compara = cates_comun.find(cate_vieja => cate_vieja == cate)

                                    if(compara)
                                        cate_comun_vieja.push(cate);
                                })
                                cates_comun = cate_comun_vieja;

                            }

                        });

                        cates_comun.forEach(function (cate) {
                            inputs_cate += `
                            <div>
                                <input type="text" readonly name='categorias[]' value='` + cate + `'>
                                <button type="button" class="btn btn-danger btn-close" onclick="eliminar_cate(this);"></button>
                            </div>
                            `;
                        })

                        in_coditm.value = coditms;
                        div_inputs.innerHTML = inputs_cate;
                    }
                },


            ]
        });

        $('#tabla').on('select.dt deselect.dt', function () {
            if (tabla.rows({selected: true}).count()) {
                tabla.button('agregar:name').enable();
                tabla.button('sacar:name').enable();
            } else {
                tabla.button('agregar:name').disable();
                tabla.button('sacar:name').disable();
            }
        });

    });


</script>
</body>
</html>